
// wire.l                                              wireframe support
// By Mark Duchaineau (free but copyrighted, see LibGen/COPYING)
//
// 10-26-93: extracted from Bezedit/Rwin/rwin.l
// 09-09-00: split win.l-dependent code into Geowin/wirewin.l


lib_include "../geo.l";

lib_public {

    lib_struct {
        int r,g,b;                             /* color of wire              */
        int n;                                 /* number of samples          */
        double *points;                        /* sample points              */
    } wire;

    lib_struct {
        int n;                                 /* number of wires            */
        wire *wires;                           /* wires framing object       */
    } wireframe;

    wireframe wireframe_create(int n,int samples,int r,int g,int b);
    void wireframe_destroy(wireframe wf);

};


wireframe wireframe_create(int n,int samples,int r,int g,int b)
{
    int i;
    wireframe wf;
    wire w;

    wf=(wireframe)mem_get(sizeof(wireframe_struct),"wireframe_create");
    wf->n=n;
    wf->wires=(wire *)mem_get(n*sizeof(wire),"wireframe_create");
    for (i=0;i<n;i++) {
        w=(wire)mem_get(sizeof(wire_struct),"wireframe_create");
        wf->wires[i]=w;
        w->r=r; w->g=g; w->b=b;
        w->n=samples;
        w->points=(double *)mem_get(3*w->n*sizeof(double),"wireframe_create");
    }

    return wf;
}

void wireframe_destroy(wireframe wf)
{
    int i;
    wire w;

    for (i=0;i<wf->n;i++) {
        w=wf->wires[i];
        mem_put((char *)w->points,"wireframe_destroy");
        mem_put((char *)w,"wireframe_destroy");
    }
    mem_put((char *)wf->wires,"wireframe_destroy");
    mem_put((char *)wf,"wireframe_destroy");
}


