
// qtilespin.l                                    spin a qtile object
// by Mark Duchaineau
//
// 11-25-99: wrote (tilespin.l)
// 12-15-99: turned into qtilespin.l
// 12-17-99: extending to test error-radius additions


lib_include "Spin/spin.l";
lib_include "../qscene.l";


qscene qs;
spin sp;
int done,dolist;


void spevent(spin sp,int e);
void do_draw();
void send_strips();


lib_main {
    int i,j,x,y,size;

    if (argc!=2) { printf("usage: qtilespin foo.qtile\n"); exit(0); }

    qs=(qscene)0;

    // create spin window
    size=940; dolist=1;
    win_screensize(&x,&y);
    sp=spin_create("qtilespin",x/2-size/2,y/2-size/2,size,size,spevent);

    // read in qtile object, check for errors
    qs=qscene_create();
    qscene_readqtile(qs,argv[1]);

    for (done=0;!done;) sel_wait(300000);
};

void spevent(spin sp,int e)
{
    int i,j;
    win w;
    qcell q;

    if (!qs) return;

    w=sp->w;
    switch (e) {
    case WIN_KEY:
        switch (w->key) {
        case 0x1b: done=1; break;
        case 'l': dolist=1; break;
        case 'L': dolist=0; break;
        case '?':
            for (i=0;i<4;i++) {
                for (j=0;j<4;j++) printf(" %19.13f",sp->mview->m[i][j]);
                printf("\n");
            }
            printf("------------------ %g\n",qs->qt0->q0->e);
            for (i=0;i<Q_IQMAX;i++) {
                for (q=qs->splitq[i],j=0;q;q=q->qq1,j++) ;
                printf("splitq[%d]: %d\n",i,j);
            }
            break;
        case 'm':
        case 'M':
            qscene_drawmode(qs,(w->key=='m'?1:0));
            break;
        case ' ':
            qscene_flush(qs);
            break;
        case 'r':
            qscene_optimize(qs);
            break;
        case '<':
            qs->ntrimax/=2; qscene_optimize(qs);
            break;
        case '>':
            qs->ntrimax*=2; qscene_optimize(qs);
            break;
        case ',':
            if (qs->ntrimax>1) { qs->ntrimax--; qscene_optimize(qs); }
            break;
        case '.':
            qs->ntrimax++; qs->debugsplit=1; qscene_optimize(qs);
            break;
        default:
            break;
        }
        break;
    case WIN_DRAW:
        do_draw();
        break;
    case WIN_QUIT:
        done=1;
        break;
    default:
        break;
    }
}

void do_draw()
{
    //if (...more) {
    //    glNewList(1,GL_COMPILE);
    //    send_strips();
    //    glEndList();
    //    ...more
    //}
    //if (dolist) glCallList(1);
    //else send_strips();

    send_strips();
}


void send_strips()
{
    qscene_draw(qs);
}


