
// mailboxsplit.l  split up a big mailbox so it is easier to use under netscape
//
// by Mark Duchaineau (free but copyrighted, see LibGen/COPYING)
//
// 05-10-00: wrote
// 06-12-00: MAX_MSGS and MAX_MEGS replace command-line arg "megs_per_chunk"


lib_include "Sys/sys.l";

#define MAX_MSGS 1024
#define MAX_MEGS 128
#define MEG 1048576

lib_main {
    int mboxsize,i,i0,chunknum,newline,msgnum;
    char *mbox,*mboxname,*chunkbasename,chunkname[1024];

    // interpret argc/v
    if (argc!=3) {
        printf("usage: mailboxsplit mboxname outbasename\n");
        exit(0);
    }
    mboxname=argv[1];
    chunkbasename=argv[2];
    mboxsize=fio_size(mboxname);
    if (mboxsize<1 || mboxsize>999*MEG) 
        { fprintf(stderr,"bad file size\n"); exit(1); }

    // read original mailbox file
    mbox=fio_read(mboxname);
    if (!mbox || mem_size(mbox)!=mboxsize)
        { fprintf(stderr,"can't read %s\n",mboxname); exit(1); }

    // output into specified chunk sizes
    i0=0; newline=1; chunknum=0; msgnum=0;
    for (i=0;i<=mboxsize;i++) {

        // check for start of next message
        if (i==mboxsize || (newline && i+4<mboxsize && mbox[i]=='F' &&
            mbox[i+1]=='r' && mbox[i+2]=='o' && mbox[i+3]=='m' &&
            mbox[i+4]==' ')) {

            msgnum++;

            // write chunk as needed
            if (i-i0>=MAX_MEGS*MEG || msgnum>=MAX_MSGS || i==mboxsize) {
                sprintf(chunkname,"%s%3.3d",chunkbasename,chunknum);
                if (fio_write(chunkname,mbox+i0,i-i0))
                    { fprintf(stderr,"write %s failed\n",chunkname); exit(1); }
                chunknum++; i0=i; msgnum=0;
            }
        }

        // update newline status
        newline=(i<mboxsize && mbox[i]==0x0a);
    }

};


